; 10 SYS8192

*=$1201

        BYTE    $0B, $12, $0A, $00, $9E, $38, $31, $39, $32, $00, $00, $00


*=$2000

        jmp init

Incasm "random.asm"

init
        jsr seed
; set up screen bitmap (192x160 pixels)
        LDA #%00010101          ; 20 lines and double char (y=160 pixel) 
        STA $9003
        LDA #24                 ; 24 columns (x=192 pixel)
        STA $9002
        LDA #204                ; 4096 screen, 4096 charmap
        STA $9005
        LDA #10
        STA $9000               ; Make place for more columns

        LDY #0
        LDX #16
ilp1
        LDA #00
        STA 37872,X
        TXA
        STA 4080,X
        INX
;        CPX #16
        BNE ilp1
        ; Clean up bitmap:
        LDA #$00
        STA $02
        LDX #$11        ; Bitmap start $1100
        LDA #0
ilpe2   STX $03
        TAY
ilp3    DEY
        STA ($02),Y
        BNE ilp3
        INX
        CPX #$20
        BNE ilpe2


end
        jsr rand
        lda $65
        tay
        and #%01111111
        sta $2
        tya
        and #%10000000
        lsr
        clc
        adc $2
        sta $2
        lda $64
        tay
        and #%01111111
        sta $3
        tya
        and #%10000000
        lsr
        lsr
        clc
        adc $3
        sta $3
        lda $63
        tay
        and #%01111111
        sta $4
        tya
        and #%10000000
        lsr
        clc
        adc $4
        sta $4
        lda $62
        tay
        and #%01111111
        sta $5
        tya
        and #%10000000
        lsr
        lsr
        clc
        adc $5
        sta $5

end1    jsr line
;        dec $5
;        lda $5
;        cmp #10
;        bne end1
end2    jmp     end
        RTS

line    ; x1=$02,y1=$03,x2=$04,y2=$05
        SEC
        LDA $02
        SBC $04
        BCC smx
        ; carry set - 04 smallest so swap
        LDA $02
        LDY $04
        STY $02
        STA $04
        LDA $03
        LDY $05
        STY $03
        STA $05
smx
        LDA $04
        SBC $02
        STA $3B         ; delta x
        SEC
        LDA $05
        SBC $03
        STA $3C         ; delta y
        LDA #0
        BCS smy
        ; $3 is larger than $5, so turn sign
        LDA $03
        SBC $05
        STA $3C         ; delta y
        LDA #1
smy
        STA $92         ; sign: 0=+, 1=-

        ldx $02
        ldy $03
        stx $93
        sty $94
        lda #0
        sta $95
        sta $96
lilp
        jsr plot
        clc
        lda $95
        adc $3b
        sta $95
        lda $93
        adc #0
        sta $93
        tax
        lda $92
        BEQ lipos
;negative delta-y
        sec
        lda $96
        sbc $3c
        sta $96
        lda $94
        sbc #0
        sta $94
        jmp liout

lipos   clc
        lda $96
        adc $3c
        sta $96
        lda $94
        adc #0
        sta $94
liout   tay
        cpy $5
        beq liend
        cpx $4
        bne lilp
liend
        RTS

plot    ; x=x, y=y
        ;x=x coordinate, y=y-coordinate
        TXA
        STA     $0
        AND     #%00000111
        TAX
        LDA     xtable,X    ; byte to store to screen for one pixel plot
        STA     $A      ; temp storage pixelbyte

        LDA     $0
        and     #%11111000
        asl     ;/8*16
        sta     $0      ;temp storage LSB
        lda     #0
        rol
        sta     $1      ;temp storage MSB
        tya
        lsr     ; 0 in bit7
        lsr
        lsr
        lsr     ;/16
        tax
        tya
        and     #$f
        clc
        jsr     tmult384
        LDA     $A
        LDY     #0
        ORA     ($0),Y
        STA     ($0),Y
        rts

xtable 
        byte %10000000,%01000000,%00100000,%00010000
        byte %00001000,%00000100,%00000010,%00000001


; fastest: use table of result: $190, 2*$190,….
; divide high&low byte into two arrays and use:
; max z=11
tmult384        ; multiply x with 384 (x=1..10) and add to $1100
        adc     lowb,x
        adc     $0
        sta     $0
        lda     highb,x
        adc     #$11
        adc     $1
        sta     $1
        rts

lowb  byte $00,$80,$00,$80,$00,$80,$00,$80,$00,$80,$00,0,0,0,0,0
highb byte $00,$01,$03,$04,$06,$07,$09,$0a,$0c,$0d,$0f,0,0,0,0,0

