; Based on "Mike"s implementation of linear congruent generator

seed
        ; Fetch seed from rasterline & VIA timers
        lda     $9119
        sta     rseed
        STA     $64
        lda     $9004
        sta     rseed+1
        STA     $63
        cmp     $9004
        beq     *-3
        lda     $9118
        STA     $65
        clc
        adc     rseed
        sta     rseed
        STA     $62
        lda     rseed+1
        adc     #0
        sta     rseed+1
        jsr     rands    ; lets start first loop with some other seed

rloop
        jsr     rand
        inc     rseed
        BNE     rloop
        rts
rseed
        byte 0,0,0

rand
; Normal 32-bit seed $3C6EF35F
; See wikipedia: Linear_congruential_generator
        LDA #$5F
        STA $65
        LDA #$F3
        STA $64
        LDA #$6E
        STA $63
        LDA #$3C
        STA $62
rands
        JSR QDRand0
        JSR QDRand2
        JSR QDRand3
        JSR QDRand1
        JSR QDRand3
        JSR QDRand0
        JSR QDRand1
        JSR QDRand3
        JSR QDRand0
        JSR QDRand2
        JSR QDRand3
        JSR QDRand2
        JSR QDRand3
        JSR QDRand1
        JSR QDRand3
        JSR QDRand1
;        LDA #$00
;        STA $70
;        STA $66
;        LDA #$80
;        STA $61
        LDA $65
        STA $8B
        LDA $64
        STA $8C
        LDA $63
        STA $8D
        LDA $62
        STA $8E
        BMI QEnd
        ORA #$80
        STA $62
;        LDA #$E9
;        LDY #$03
;        JSR $D867
QEnd    RTS
QDRand0 CLC
        LDA $65
        ADC $8B
        STA $65
        LDA $64
        ADC $8C
        STA $64
        LDA $63
        ADC $8D
        STA $63
        LDA $62
        ADC $8E
        STA $62
        RTS
QDRand1 CLC
        LDA $64
        ADC $8B
        STA $64
        LDA $63
        ADC $8C
        STA $63
        LDA $62
        ADC $8D
        STA $62
        RTS
QDRand2 CLC
        LDA $63
        ADC $8B
        STA $63
        LDA $62
        ADC $8C
        STA $62
        RTS
QDRand3 ASL $8B
        ROL $8C
        ROL $8D
        ROL $8E
        RTS